package com.zipcodewilmington.generic.group;

import com.zipcodewilmington.generic.identifiables.IdentifiableInterface;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;
import java.util.function.Predicate;

/**
 * @author leon on 06/12/2018.
 */
public class Group<A,B>  extends AbstractGroup{


     List<A >serializableList =new ArrayList<>() ;
    List<B>list=new ArrayList<>() ;

    public Group() {
    }

    public Group( List<A> serializableList,List<B> list) {

        this.serializableList = serializableList;
        this.list = list;
    }


    @Override
    public Integer count() {

        return list.size() ;
    }

    @Override
    public void insert(IdentifiableInterface object) {
        list.add((B) object);
        serializableList.add((A) object);
    }

    @Override
    public void delete(IdentifiableInterface object) {
        list.remove(object );

    }

    @Override
    public void delete(Serializable serializable) {
      serializableList.remove(serializable );
      list.remove(serializable );

    }

    @Override
    public Boolean has(IdentifiableInterface object) {

        return list.contains(object ) && serializableList.contains(object ) ;
    }

    @Override
    public Boolean has(Serializable serializable) {

        return  list.contains(serializable )&&serializableList.contains(serializable ) ;
    }

    @Override
    public List filter(Predicate predicate) {
        List<A > filteredList = new ArrayList<>();

                       for (int i = 0; i < serializableList .size(); i++) {
                              if (predicate.test(serializableList.get(i))) {

                                       filteredList.add(serializableList .get(i));
                }
            }
        return filteredList;

    }

    @Override
    public Class getIdentityType() {

        return serializableList.getClass() ;
    }

    @Override
    public Class getIdentifiableType() {

        return  Group.class ;
    }

}
